function getCookie(cname) {
    var name = cname + "=";
    var decodedCookie = decodeURIComponent(document.cookie);
    var ca = decodedCookie.split(';');
    for(var i = 0; i <ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
}

function clearInputValueById( currentObject ) {
    var currentId = '#' + jQuery(currentObject).attr('id');
    jQuery( currentId ).val('');
}

function updateCartFragment() {
    $fragment_refresh = {
        url: woocommerce_params.ajax_url,
        type: 'POST',
        data: { action: 'woocommerce_get_refreshed_fragments' },
        success: function( data ) {
            if ( data && data.fragments ) {          
                jQuery.each( data.fragments, function( key, value ) {
                    jQuery(key).replaceWith(value);
                });
           
                jQuery('body').trigger( 'wc_fragments_refreshed' );
            }
        }
    };

    jQuery.ajax( $fragment_refresh );  
}

function displayModalInfo( message, backToCartButton = false, currentObject = '' ) {
	clearInputValueById(currentObject);

    jQuery( "#checkoutModal" ).remove();
    jQuery( "#checkout-modal" ).append('<div class="modal fade" id="checkoutModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">\
        <div class="modal-dialog" role="document">\
            <div class="modal-content">\
            <div class="modal-header">\
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>\
                <h4 class="modal-title" id="myModalLabel">' + message + '</h4>'
                + (( backToCartButton == true ) ? '<p><a href="/comanda" class="back-to-cart">Inapoi la comanda</a></p>' : '')
            + '</div>\
            </div>\
        </div>\
    </div>\
    ');

    jQuery('#checkoutModal').modal('show');
}

function getShippingCost() {
    var checked = 0;

    var delivery_method = jQuery('#delivery_method').val();

    if( delivery_method == '' ) {
        delivery_method = jQuery('input[name="delivery_method"]').val();
    }

    if (delivery_method == 'ridicare-personala' || delivery_method == 'servire-la-restaurant') {
        checked = 1;
    }

    jQuery.ajax({
        type: 'POST',
        url: wc_checkout_params.ajax_url,
        data: {
            'action': 'woo_get_ajax_data',
            'billing_ups': checked,
            'delivery_method': delivery_method,
        },
        success: function (result) {
            jQuery('body').trigger('update_checkout');
        },
        error: function (error) {
            console.log(error); // just for testing
        }
    });
}

function selectOptionValue( value, timeout = 500 ) {
    setTimeout(function(){ 
        jQuery( '#areas option' ).css( 'display', 'none' );
        jQuery( '#areas option' + '.' + value ).css( 'display', 'block' );
        jQuery( '#areas option' ).removeAttr("selected");
        jQuery( '#areas' ).find('.' + value + ':first').prop('selected', true);
    }, timeout);
}

jQuery(document).ready(function( $ ) {
    setTimeout( getShippingCost(), 4000);
    var initialValue = $('#billing_city').val();
    selectOptionValue(initialValue);

    $(document).on("change", "#billing_city", function () {
        var selectedValue = $(this).val();
        selectOptionValue(selectedValue, 100);
    });

    $(document).on("change", "#areas", function () {
        $('body').trigger('update_checkout');
    });

    $("select[name='payment_method']").on('change', function() {
        console.log( this.value );
        if( this.value == "netopiapayments" ){ // credit_card
            $('#netopia_method_pay').val('credit_card');
        }
    });
});